<script setup lang="tsx">
import { reactive, ref, unref } from 'vue'
import {
  getReCustomerIdentityListApi,
  saveReCustomerIdentityApi,
  delReCustomerIdentityListApi,
  delReCustomerIdentityApi,
  queryReCustomerIdentityApi,
  exportExcelApi
} from '@/api/amld/ReCustomerIdentity/ReCustomerIdentity'
import { TableData } from '@/api/amld/ReCustomerIdentity/ReCustomerIdentity/types'
import { useTable } from '@/hooks/web/useTable'
import { useI18n } from '@/hooks/web/useI18n'
import { Table, TableColumn } from '@/components/Table'
import { ElButton, ElLink, ElLoading, ElPopconfirm, ElMessage } from 'element-plus'
import { Search } from '@/components/Search'
import { FormSchema } from '@/components/Form'
import { ContentWrap } from '@/components/ContentWrap'
import Write from './components/Write.vue'
import { Dialog } from '@/components/Dialog'
import { getWidth } from '@/utils';
import Detail from './components/Detail.vue'
import { useRouter } from 'vue-router'
const { push } = useRouter()
const { t } = useI18n()

const ids = ref<string[]>([])

const { tableRegister, tableState, tableMethods } = useTable({
  fetchDataApi: async () => {
    const { currentPage, pageSize } = tableState
    const res = await getReCustomerIdentityListApi({
      pageIndex: unref(currentPage),
      pageSize: unref(pageSize),
      ...unref(searchParams)
    })
    return {
      list: res.body.list,
      total: res.body.total
    }
  },
  fetchDelApi: async () => {
    const res = await delReCustomerIdentityListApi(unref(ids));
    return !!res;
  },
})

const { loading, dataList, total, currentPage, pageSize } = tableState
const { getList, getElTableExpose, delList, refresh } = tableMethods

const tableColumns = reactive<TableColumn[]>([
  {
    field: 'selection',
    type: 'selection',
    fixed: true
  },
  {
    field: 'custcode',
    label: '客户号'
  },
  {
    field: 'custname',
    label: '客户名称'
  },
  {
    field: 'custpptype',
    label: '客户类型'
  },
  {
    field: 'custcardtype',
    label: '证件类型'
  },
  {
    field: 'custcardno',
    label: '证件号'
  },
  {
    field: 'dcorgan',
    label: '开户网点'
  },
  {
    field: 'sblx',
    label: '识别类型'
  },
  {
    field: 'attribute2',
    label: '开户日期'
  },
  {
    field: 'action',
    label: "状态",
    width: 100,
    fixed: 'right',
    slots: {
      default: (data: any) => {
        return (
          <>
            <ElLink type="primary" underline={false} onClick={() => action("/caseManageT/CustomerIdentification",data.row, 'edit')}>
              重新识别
            </ElLink>
          </>
        )
      }
    }
  }
].map(item => ({ minWidth: item.label ? getWidth(item.label) : 120, ...item }) as TableColumn))

const searchSchema = reactive<FormSchema[]>([
  {
    field: 'custcode',
    label: '客户号',
    componentProps: {},
    component: 'Input'
  },
  {
    field: 'custname',
    label: '客户名称',
    componentProps: {},
    component: 'Input'
  },
  {
    field: 'custpptype',
    label: '客户类型',
    componentProps: {},
    component: 'Select'
  },
  {
    field: 'dcorgan',
    label: '开户网点',
    componentProps: {},
    component: 'Select'
  },
  {
    field: 'sblx',
    label: '识别类型',
    componentProps: {},
    component: 'Select'
  }
])

const searchParams = ref({})
const setSearchParams = (data: any) => {
  searchParams.value = data
  getList()
}

const dialogVisible = ref(false)
const dialogTitle = ref('')

const currentRow = ref()
const actionType = ref('')

const writeRef = ref<ComponentRef<typeof Write>>()

/**单行查询**/
const action = async (path: string,row: TableData, type: string) => {
  push({path,query:row})
  // let detailLoading = ElLoading.service({
  //   background: 'rgba(0, 0, 0, 0.7)'
  // })
  // const res = await queryReCustomerIdentityApi(row.pkid)
  //   .catch(() => {})
  //   .finally(() => {
  //     detailLoading.close()
  //   })
  // detailLoading.close()
  // if (res) {
  //   const data = res.body.result
  //   dialogTitle.value = t(type === 'edit' ? 'tableDemo.edit' : 'tableDemo.detail')
  //   actionType.value = type
  //   currentRow.value = data
  //   dialogVisible.value = true
  // }
}

const AddAction = () => {
  dialogTitle.value = t('tableDemo.add')
  currentRow.value = undefined
  dialogVisible.value = true
  actionType.value = 'add'
}
const saveLoading = ref(false)

/** 保存 **/
const save = async () => {
  const write = unref(writeRef)
  const formData = await write?.submit()
  if (formData) {
    saveLoading.value = true
    const res = await saveReCustomerIdentityApi(formData)
      .catch(() => {})
      .finally(() => {
        saveLoading.value = false
      })
    if (res) {
      dialogVisible.value = false
      currentPage.value = 1
      getList()
    }
  }
}

const delLoading = ref(false)

/** 批量删除  **/
const delDataBatch = async () => {
  const elTableExpose = await getElTableExpose()
  ids.value = elTableExpose?.getSelectionRows().map((v: TableData) => { v.pkid }) || []
  delLoading.value = true
  await delList(unref(ids).length).finally(() => {
    delLoading.value = false
  })
}

/** 单行删除 */
const delData = async (row: TableData) => {
  const res = await delReCustomerIdentityApi(row.pkid)
  if (res) {
    const { code, errMsg } = res.head
    if (code === '0') {
      ElMessage.success('删除成功!')
      getList()
    } else {
      ElMessage.error(errMsg || '删除失败!')
    }
  }
}

const disabled = ref(true)

const onSelectionChange = (selection: TableData[]) => {
  disabled.value = selection.length === 0
}

/** 导出Excel */
const exportExcel = async () => {
  const data = { ...unref(searchParams) }
  await exportExcelApi(data)
}
</script>

<template>
  <ContentWrap>
    <Search :schema="searchSchema" @reset="setSearchParams" @search="setSearchParams" />

    <Table
      :columns="tableColumns"
      v-model:pageSize="pageSize"
      v-model:currentPage="currentPage"
      default-expand-all
      node-key="pkid"
      :data="dataList"
      :loading="loading"
      :pagination="{
        total
      }"
      @selection-change="onSelectionChange"
      @register="tableRegister"
      @refresh="refresh"
    >
      <template #buttons>
        <ElButton type="primary" @click="AddAction">{{ t('tableDemo.add') }}</ElButton>
        <ElButton type="primary" @click="exportExcel()">导出</ElButton>
        <ElButton :loading="delLoading" type="primary" :disabled="disabled" @click="delDataBatch()">
          {{ t('tableDemo.del') }}
        </ElButton>
      </template>
    </Table>
  </ContentWrap>

  <Dialog v-model="dialogVisible" :title="dialogTitle">
    <Write
      v-if="actionType !== 'detail'"
      ref="writeRef"
      :current-row="currentRow"
      :action-type="actionType"
    />
    <Detail v-if="actionType === 'detail'" :current-row="currentRow" />
    <template #footer>
      <ElButton v-if="actionType !== 'detail'" type="primary" :loading="saveLoading" @click="save">
        {{ t('dialogDemo.save') }}
      </ElButton>
      <ElButton @click="dialogVisible = false">{{ t('dialogDemo.close') }}</ElButton>
    </template>
  </Dialog>
</template>